import java.sql.*;
import java.lang.*;
/*------------------------------------------------------------------------
	BBS ͺ̽   

		id				Primary key
		wname			message author
		email			author's email address
		homepage		author's homepage
		subject			subject
		msgbody			message
		wtime			writing time YYYY-MM-DD HH:MM:SS
		vcnt			count of view
		p_id			parent message
		t_id			id in thread
		t_step			thread step
--------------------------------------------------------------------------*/

class  createDatabase
{
	public static void main(String[] args) 
	{
		// JDBC Ŭ о ̰, Statement մϴ. 
		try
		{
			Class.forName("org.gjt.mm.mysql.Driver").newInstance();	
		}
		catch(ClassNotFoundException ce)
		{
			System.out.println("Ŭ ã ߽ϴ.");
		}
		catch(InstantiationException ie)
		{
			System.out.println("Ŭ  ߽ϴ.");
		}
		catch(IllegalAccessException ie)
		{
			System.out.println("׼  ߽ϴ.");
		}
		Connection con;	
		Statement stmt;
		con = java.sql.DriverManager.getConnection("jdbc:mysql://localhost/board?user=board&password=");
		stmt = con.createStatement();
		String		board = "create table board ( 
					id			int				not null auto_increment,
					msgno		int				not null,
					wname		varchar(35)		not null,
					email		varchar(200)			,
					homepage	varchar(100)			,
					subject		varchar(255)	not null,
					msgbody		text			not null,
					passwd		char(20)		not null,
					wtime		datetime,
					vcnt		int				default 0 not null,
					p_id		int				default 0 not null,
					t_id		int				default 0 not null,
					t_step		int				default 0 not null,
					PRIMARY KEY (id),
					UNIQUE		(msgno),
					INDEX		(p_id),
					INDEX		(t_id),
					INDEX		(t_step),
					INDEX		(wname),
					INDEX		(subject)
												)";
		String		filelist = "create table filelist (
					id			int				not null auto_increment,
					filename	varchar(255)	not null,
					msgno		int				not null,
					PRIMARY KEY (id),
					INDEX		(msgno)
					)";

		stmt.executeQuery(board);
		stmt.executeQuery(filelist);
	
		stmt.close();
		con.close();
	}
}
